package fr.username404.snowygui.rendering

import com.mojang.blaze3d.platform.GlStateManager
import com.mojang.blaze3d.systems.RenderSystem
import com.mojang.blaze3d.vertex.BufferBuilder
import com.mojang.blaze3d.vertex.DefaultVertexFormat
import com.mojang.blaze3d.vertex.PoseStack
import com.mojang.blaze3d.vertex.Tesselator
import net.minecraft.client.Minecraft
import org.lwjgl.opengl.GL11

internal object Util {
    private val tessellator: Tesselator = Tesselator.getInstance()
    private val buffer: BufferBuilder = tessellator.builder
    fun UIRect(x: Int, y: Int, width: Int, height: Int, color: Int = -0x1, opacity: Float) {
        val r = (color shr 16 and 255) / 255.0f
        val g = (color shr 8 and 255) / 255.0f
        val b = (color and 255) / 255.0f
        RenderSystem.enableBlend()
        RenderSystem.disableTexture()
        RenderSystem.blendFuncSeparate(
            GlStateManager.SourceFactor.SRC_ALPHA,
            GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA,
            GlStateManager.SourceFactor.ONE,
            GlStateManager.DestFactor.ZERO
        )
        with(buffer) {
            begin(GL11.GL_QUADS, DefaultVertexFormat.POSITION_COLOR)
            vertex(x.toDouble(), y.toDouble() + height, 0.0).color(r, g, b, opacity).endVertex()
            vertex(x.toDouble() + width, y.toDouble() + height, 0.0).color(r, g, b, opacity).endVertex()
            vertex(x.toDouble() + width, y.toDouble(), 0.0).color(r, g, b, opacity).endVertex()
            vertex(x.toDouble(), y.toDouble(), 0.0).color(r, g, b, opacity).endVertex()
            tessellator.end()
            RenderSystem.enableTexture()
            RenderSystem.disableBlend()
        }
    }
    fun UIString(poseStack: PoseStack, string: String, i: Float, j: Float) {
        Minecraft.getInstance().font.draw(poseStack, string, i, j, 10)
    }
}